import os 
from bs4 import BeautifulSoup
from jinja2 import Template
from temp import temp

def makeReport(temp,out_dir:str):
    template = Template(temp)
    #解析表
    fastpReport = os.path.join(out_dir,"customer_files/01_Quality_Control/01_Fastp/fastpReport.html")
    fastq_screen = os.path.join(out_dir,"customer_files/01_Quality_Control/02_FastpScreen/fastqScreenReport.html")
    contigNxstats = os.path.join(out_dir,"customer_files/03_Assessment/01_contigNxstatAssessment/contigNxStat.html")
    assemblyQualityAssessment = os.path.join(out_dir,"customer_files/03_Assessment/02_assemblyQualityAssessment/assemblyQualityAssessment.html")
    readCountAccess = os.path.join(out_dir,"customer_files/03_Assessment/03_readCountAssess/readCountAssess.html")
    keggpathway = os.path.join(out_dir,"customer_files/08_KEGG/KEGG_ORA/pathway")
    with open(fastpReport, "rb") as file:
        html = file.read()
        soup = BeautifulSoup(html, 'html.parser')
    fastpBefore,fastpAfter = soup.find_all('table')

    with open(fastq_screen, "rb") as file:
        html = file.read()
        soup = BeautifulSoup(html, 'html.parser')
    fastq_screen = soup.find('table')

    with open(contigNxstats, "rb") as file:
        html = file.read()
        soup = BeautifulSoup(html, 'html.parser')
    CGcontent,N50,Nx = soup.find_all('table')

    with open(assemblyQualityAssessment, "rb") as file:
        html = file.read()
        soup = BeautifulSoup(html, 'html.parser')
    uniportAlign = soup.find('table')

    with open(readCountAccess, "rb") as file:
        html = file.read()
        soup = BeautifulSoup(html, 'html.parser')
    compareRate = soup.find('table')

    #修改表格属性
    for i in [fastpBefore,fastpAfter,fastq_screen,CGcontent,N50,Nx,uniportAlign,compareRate ]:
        i["class"] = "table table-striped table-hover table-sm"
        del i['border']
        print(i)

    #创建keggpathway的下拉菜单
    pathFiles = [i for i in os.listdir(keggpathway) if i.endswith("html")]
    contents = "\n".join([f"<option value=customer_files/08_KEGG/KEGG_ORA/pathway/{i}>{i}</option>" for i in pathFiles])
    #<br> <p class='text-center'><iframe id='showme' src=customer_files/05_联合通路图/hsa02010_result.html name=customer_files/05_联合通路图/hsa02010_result width="1350" height="800"></iframe></p>
    firstImg = f"<p class='text-center'><iframe id='showme' src=customer_files/08_KEGG/KEGG_ORA/pathway/{pathFiles[0]} name={pathFiles[0]} width='1350' height='800'></iframe></p>"
    with open(os.path.join(out_dir,"reportTest.html"),"w",encoding='utf-8') as report:
        report.write(template.render(fastpBefore = fastpBefore,
                                     fastpAfter = fastpAfter,
                                     fastq_screen = fastq_screen,
                                     CGcontent = CGcontent,
                                     N50 = N50,
                                     Nx = Nx,
                                     uniportAlign = uniportAlign,
                                     compareRate = compareRate,
                                     contents= contents,
                                     firstImg = firstImg))

makeReport(temp,"C://Users/zhouy/Documents/无参转录组/结题报告")
